*********************************************************************
*
* Startup code with screen handling.
* Created for #amycoders smallest gouraud compo by Flynn/Energy
*
* Some additional stuff + extended palettes by Azure/Artwork :)
*
* Adapted for the line-compo 10.09.97 Azure/Artwork
*
* Chunky->Planar routine by our dear guru, Kalms :)
* ASM-One is not my real fave but who cares ;)
* No enforcer hits and no bugs as far as I know :)
*
* YOUR CODE GOES AT THE END OF THIS SOURCE.
*
*********************************************************************
* Set the incdir value to the appropriate one.

	incdir	"dh1:s_aga11/linecomp/"	;Change this path !!
					

	include	starter.s		; Startup Code

*********************************************************************

	lea	screen2,A1		; Bitplane address
	move.l	a1,d0
	
	lea	bmap2,a2

	moveq	#7,d7
		
fil2:	
	addq.w	#2,a2			; Points to BPL1PTH

	swap	d0			; Fill BPLxPTH for 8 planes
	move.w	d0,(a2)+		; secondary copperlist.

	swap	d0
	addq.w	#2,a2

	move.w	d0,(a2)+
	add.l	#(8192),d0
	dbf	d7,fil2


	lea	screen1,A1		; Bitplane address
	move.l	a1,d0
	
	lea	bmap,a2

	moveq	#7,d7
		
fil1:	
	addq.w	#2,a2			; Points to BPL1PTH

	swap	d0			; Fill BPLxPTH for 8 planes
	move.w	d0,(a2)+		; primary copperlist.

	swap	d0
	addq.w	#2,a2

	move.w	d0,(a2)+
	add.l	#(8192),d0
	dbf	d7,fil1

*********************************************************************

	move.w	#256,d0	
	move.w	#256,d1
	moveq	#0,d2
	moveq	#0,d3
	moveq	#0,d4
	move.l	#8192,d5
	bsr	c2p1x1_8_cpu5_init	; chunky->planar init code

	bsr	mausinit		; Mousecode - Init
	
*********************************************************************

	lea	sintable,a1		; Sine table
	jsr	_initcode		; Your init code
	movem.l	d0-d7/a3-a6,-(sp)	; Keep registers


_main
	lea	chunkyscreen,a0		; chunky screen
	lea	screen2,a1		; planar screen
	bsr	c2p1x1_8_cpu5		; chunky->planar
	move.l	#Copper2,$dff080 	; set copperlist #2

	bsr	_getmaus		; mouse coords

	bsr	clearbuffer		; clear chunkybuffer

	movem.l	(sp)+,d0-d7/a3-a6	; Get registers

	lea	chunkyscreen,a0		; chunky buffer
	lea	sintable,a1
	jsr	_moveline		; moveline
	
	movem.l	d0-d7/a3-a6,-(sp)	; Store again


	lea	chunkyscreen,a0		; chunky screen
	lea	screen1,a1		; planar screen
	bsr	c2p1x1_8_cpu5		; chunky->planar
	move.l	#Copper,$dff080		; trigger Copperlist #1


	bsr	_getmaus		; mouse coords
	
	bsr	clearbuffer		; clear chunky buffer

	movem.l	(sp)+,d0-d7/a3-a6	; Get regs

	lea	chunkyscreen,a0
	lea	sintable,a1
	jsr	_moveline		; moveline

	movem.l	d0-d7/a3-a6,-(sp)	; Store again


	btst	#6,$bfe001		; Mouse check
	bne.w	_main			; no?

	movem.l	(sp)+,d0-d7/a3-a6	; Get back
	rts				; ende

*********************************************************************
*
* Kalm's c2p_1x1_8_cpu5
*
*********************************************************************

	include	c2p1x1.i
	

*********************************************************************
*
* Clear chunky buffer
*
*********************************************************************

clearbuffer
	move.w	#512-1,d7
	moveq	#0,d0
	lea	chunkyscreen,a0
	
_clear
	rept	32
	move.l	d0,(a0)+
	endr

	dbf	d7,_clear

	rts

*********************************************************************
*
* Mouse crap
*
*********************************************************************

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;Testmaus
;(W) 27.7.1995 by AZURE/ARTWORK
;Input : None
;Scratch:d0-d3
;Output:
;
;	d2=Rel X Movement
;	d3=Rel Y Movement
;
;Mausinit.. Init Testmaus
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Mausinit:
	moveq	#0,d0
	move	d0,$dff036
	rts
	
Testmaus:

	move	$dff00a,d0
	move	d0,d1
	and	#$ff,d0
	lsr	#8,d1	;Y

	move	.oldx,d2
	move	.oldy,d3
	sub	d0,d2
	sub	d1,d3
	move	d0,.oldx
	move	d1,.oldy

	move	#127,d0
	cmp	d0,d2
	blt.s	.mox1
	eor	#$ff,d2
.mox1	
	cmp	d0,d3
	blt.s	.mox2
	eor	#$ff,d3
.mox2
	neg	d0
	cmp	d0,d2
	bgt.s	.mox3
	neg	d2
	add	#-255,d2		
.mox3
	cmp	d0,d3
	bgt.s	.mox4
	neg	d3
	add	#-255,d3
.mox4
	neg	d2
	neg	d3
	rts
	
.oldx	dc.w	0
.oldy	dc.w	0

_getmaus:
	bsr	testmaus

	btst	#10,$dff016	;Right mousebutton ?
	bne.s	.doxy
	
	add	#2,MouseX
	add	d3,MouseY
	and	#$3ff,MouseX
	and	#$3ff,MouseY
	rts
.doxy
	add	#0,MouseX
	add	#0,MouseY
	and	#$3ff,MouseX
	and	#$3ff,MouseY
	rts
		
*********************************************************************
*
* Some data
*
*********************************************************************

sintable	include	sinetabelle.i	; sine table
MouseX		dc.w	0		; Mouse coords.
MouseY		dc.w	150

*********************************************************************
*
* object
*
*********************************************************************


*********************************************************************
*
* Chunky screen
*
*********************************************************************


	section	fastdata,bss_f

chunkyscreen	ds.b	256*256


*********************************************************************
*
* Copper lists
*
*********************************************************************

	section	coppers,data_c

Copper	
	dc.w	$1FC,3		; Fetch Mode
	dc.w	$106,$C40
	dc.w	$100,$0210	; 8 planes
	dc.w	$102,$8800	; Scroll
	dc.w	$104,$224	; Priority
	dc.w	$108,$0000	;
	dc.w	$10A,$0000	; Modulos
	dc.w	$1e4,$2100	; diwhigh

Cols

;------------------------------------------------------------------
;
; Comment out the palette you like, here :)
; Dont forget the second copperlist, or you will get some
; strobo-effects!
;
;------------------------------------------------------------------

	include rotmatt.col

	dc.w	$8E,$2482	
	dc.w	$90,$24a3	
	dc.w	$92,$0048
	dc.w	$94,$00a8

bmap	dc.w	$E0,0000	; BitPlane pointers.
	dc.w	$E2,0000
	dc.w	$E4,0000	; 2
	dc.w	$E6,0000
	dc.w	$E8,0000	; 3
	dc.w	$EA,0000
	dc.w	$EC,0000	; 4
	dc.w	$EE,0000	
	dc.w	$F0,0000	; 5
	dc.w	$F2,0000
	dc.w	$F4,0000	; 6
	dc.w	$F6,0000
	dc.w	$F8,0000	; 7
	dc.w	$FA,0000	
	dc.w	$FC,0000	; 8
	dc.w	$FE,0000
		
	dc.l	-2
	dc.l	-2

Copper2	
	dc.w	$1FC,3		; Fetch Mode
	dc.w	$106,$C40
	dc.w	$100,$210	; 8 planes
	dc.w	$102,$8800	; Scroll
	dc.w	$104,$224	; Priority
	dc.w	$108,$0000	;
	dc.w	$10A,$0000	; Modulos
	dc.w	$1e4,$2100	; diwhigh

Cols2
	include rotmatt.col

	dc.w	$8E,$2482	; 
	dc.w	$90,$24a3	; 
	dc.w	$92,$0048
	dc.w	$94,$00a8

bmap2	dc.w	$E0,0000	; BitPlane pointers.
	dc.w	$E2,0000
	dc.w	$E4,0000	; 2
	dc.w	$E6,0000
	dc.w	$E8,0000	; 3
	dc.w	$EA,0000
	dc.w	$EC,0000	; 4
	dc.w	$EE,0000	
	dc.w	$F0,0000	; 5
	dc.w	$F2,0000
	dc.w	$F4,0000	; 6
	dc.w	$F6,0000
	dc.w	$F8,0000	; 7
	dc.w	$FA,0000	
	dc.w	$FC,0000	; 8
	dc.w	$FE,0000
		
	dc.l	-2
	dc.l	-2


*********************************************************************
*
* Planar screens.
*
*********************************************************************

	section	planarscreens,bss_c

screen1	ds.b	256*256
screen2	ds.b	256*256

*********************************************************************

	section	yourcode,code

*********************************************************************
*
*This routine is drawing a nice object using your lineroutine
*
*a0 chunky screen
*a1 sintab
*
*dont look here - its a total mess.. :)
*
*********************************************************************

_moveline:

.wait 
	move.l	$dff004,d0
	and.l	#$0001ff00,d0
	cmp.l	#$00004000,d0
	bne.s	.wait

	move	MouseY,.addstep
	
	lea	256*2(a1),a2
	move	MouseX,d6
	move	#128,d0
	move	#128,d1
	move	#127,d7		;128 lines
.loop
	move	d0,d2
	move	d1,d3
	
	moveq	#0,d0
	moveq	#0,d1

	move	d7,d4
	add	d4,d4
	not.b	d4
	
	move	d6,d5
	and	#$3ff,d5
	move	(a1,d5.w*2),d0
	muls	d4,d0
	swap	d0
	add	#128,d0
	
	move	(a2,d5.w*2),d1
	muls	d4,d1
	swap	d1
	add	#128,d1

	movem.l	d0-d7/a0-a6,-(a7)
	move	d7,d4
	bsr	_line
	movem.l	(a7)+,d0-d7/a0-a6

	add	.addstep,d6
	dbf	d7,.loop

	move.l	$dff004,d0
	and.l	#$0001ff00,d0
	lsr.l	#8,d0
	sub.l	#$40,d0
	
	add.l	d0,alltime
	and	#$1ff,d0
.lop
	move.b	#127,(a0)+
	dbf	d0,.lop
		
	addq.l	#1,events
	move.l	alltime,d0
	divs.l	events,d0
	move.l	d0,average
	rts
	
.addstep	dc.w	0
.starttime	dc.l	0
alltime		dc.l	0
events		dc.l	0
average		dc.l	0
*********************************************************************
*
* Your init code comes here.
*
*********************************************************************

_initcode
a

b
	rts
		
	
*********************************************************************
*
* Your line routine.
* Every time you are given: A0 : Chunky Screen (256x256x8)
*
* d0/d1  x1/y1
* d2/d3  x2/y2
* d4     colors
*
* other registers are in undefined state !!
* you may trash all regs except a7
*
*********************************************************************

_line
c

d
	rts

	printt	"Length of your code:"
	printv	((b-a)+(d-c))


**********************************************************************
*
* Put your tables here
*
**********************************************************************
	section yourbss,bss


