;-----------------------------------------
;                                        
; Generic Demo Startup Code version 1.10
; Coded by Flynn/Capsule in 1997.        
;                                        
; * Works on ALL Amigas.                 
; * Assembles with DevPac/ASM-One/PHX       
; * Aimed at AGA/'020+ demos.            
; * Full 68000 - 68060 support.
;                                        
;-----------------------------------------

;-----------------------------------
; Some useful macro is defined here.
;-----------------------------------

Write   MACRO
	movem.l  d1-d3,-(sp)               
        move.l   \2,d1                     
        move.l   #\1,d2                    
        move.l   #\1_long,d3               
	;bsr	Writer			; Output removed to support ASM-One
	movem.l	(sp)+,d1-d3
	ENDM


;---------------------
; Here comes the code.
;---------------------

	section	startup,code
	
_Start

;-----------------
; Processor check.
;-----------------

        move.l  4.w,a6          ; exec base.
        move.w  $128(a6),d0     ; AttnFlags

        lea     _cpu,a1
        lea     _status,a2
        
        btst    #0,d0
        bne.s   _010            ; 68010
        move.b  #"0",(a1)
        move.w  #"ER",(a2)
        bra.b   _done

_010    btst    #1,d0
        bne.s   _020            ; 68020
        move.b  #"1",(a1)
        move.w  #"ER",(a2)
        bra.b   _done

_020    btst    #2,d0
        bne.s   _030            ; 68030
        move.b  #"2",(a1)
        bra.b   _done
_030    btst    #3,d0
        bne.s   _040            ; 68040
        move.b  #"3",(a1)
        bra.b   _done
_040    btst    #7,d0
        bne.s   _060            ; 68060
        move.b  #"4",(a1)
        bra.b   _done
_060    move.b  #"6",(a1)

_done   ;bsr OpenDOS            ; open DOS.library  *** REMOVED to support ASM-One
        Write _header,_stdout   ; write header

        bsr     AGA_Check       ; Check for AGA chip set

        cmp.l   #"AGA.",d7
        bne     _error1

        Write _aga,_stdout      

        bra     _continue

_error1 lea     _status,a2
        move.w  #"ER",(a2)
        Write   _not_aga,_stdout
        bra     _failed

_continue

        move.l  4.w,a6
        cmp.b   #50,530(A6)     ; Check for PAL/NTSC
        bne     _nopal

        Write   _pal,_stdout

        bra     _cont2

_nopal  lea     _status,a2
        move.w  #"ER",(a2)
        Write   _ntsc,_stdout
        bra     _failed

_cont2
        lea     _status,a2
        cmp.w   #"ER",(a2)
        bne     _systemok
_failed
        Write   _abort1,_stdout

;        bsr CloseDOS              ; cerramos librera DOS
        moveq #0,d0                ; retorno al Shell sin error
        rts                        ; retorno

_systemok

;Now we can check for chip/fast memory...


        lea     _chipmem,a2

        move.l  4.w,a6          ; exec base
        move.l  #$00020002,d1   ; chip mem
        jsr     -216(a6)        ; _LVOAvailMem
        move.l  d0,(a2)+
        move.l  #$00020004,d1   ; fast mem
        jsr     -216(a6)        ; _LVOAvailMem
        move.l  d0,(a2)

; And now let's convert the data into ASCII...

        lea     _chipmem,a2
        lea     _cmem,a3        ; string pointer
        lea     _values,a4      ; Table for Hex-Ascii conversion
        move.l  (a2)+,d0        ; amount of chip mem

        bsr     converter       ; do conversion.

        move.l  (a2),d0         ; amount of fast mem
        lea     _fmem,a3        ; string pointer

        bsr     converter       ; convert values

        Write   _chip,_stdout

        lea     _fastmem,a2
        move.l  (a2),d0
        cmp.l   #0,d0           ; No fast mem?
        bne     _fast_ok

        Write   _abort2,_stdout
;       bsr     CloseDOS
        moveq   #0,d0
        rts

_fast_ok
        Write   _passd,_stdout

;        bsr     CloseDOS       ; close dos.library   **** REMOVED
        
;--------------------------------------------------
; Close system and store old IRQ/DMA/Copper values.
;--------------------------------------------------

        lea     gfx_lib,a1      ; open graphics.library
        moveq   #0,d0
        move.l  4.w,a6          ; exec base
        jsr     -552(a6)        ; _LVOOpenLibrary

        move.l  d0,_gfxbase     ; store open gfxlibrary pointer
        move.l  d0,a6
        move.l  38(a6),_oldcopper       ; store old copper list address
        move.l  34(a6),_oldview         ; store old WB view.

;        jsr     -228(a6)        ; _LVOWaitBlitt
;        jsr     -456(a6)        ; _LVOOwnBlitter                

        moveq   #0,d7
        move.l  d7,a1

        jsr     -222(a6)        ; _LVOLoadView(Null)
        jsr     -270(a6)        ; _LVOWaitTOF
        jsr     -270(a6)        ; _LVOWaitTOF

        move.l  4.w,a6
        jsr     -132(a6)        ; _LVOForbid

        lea     GetVBR(pc),a5
        jsr     -$1e(a6)        ; _LVOSupervisor

        move    $DFF01C,_intenar
        move    $DFF01E,_intreqr
        move    $DFF002,_dmaconr
        move    $DFF010,_adkconr

	move    #%0111111111111111,$DFF09A      ; Intena
	move    #%1110000000100000,$DFF09A      ; enable needed IRQs

        move.l  _gfxbase,a6
        jsr     -270(a6)        ; WaitTOF

	move    #%0111111111111111,$DFF096      ; DMACONW
	move    #%1000001111000000,$DFF096

	move.l  _vectorbase,a0
	move.l  $6c(a0),_int3save               ; store original vblank int.
                
        jsr     _maincode       ; call main demo code


        move.l  _vectorbase,a0
        move.l  _int3save,$6c(a0)       ; restore old level3 int.

        move    _intenar,d7
        bset    #$f,d7
        move    d7,$DFF09A              ; restore old interrupts.


        move    _intreqr,d7
        bset    #$f,d7
        move    d7,$DFF09C              ; the same...   
        
        move    _dmaconr,d7
        bset    #$f,d7
        move    d7,$DFF096              ; restore old DMAs

        move    _adkconr,d7
        bset    #$f,d7
        move    d7,$DFF09E              ; restore Adkcon

        move.l  _gfxbase,a6
        move.l  _oldview,a1
        jsr     -222(a6)                ; _LVOLoadview(OldView)

        move.l  _oldcopper,$dff080      ; restore old copper list.

 ;       jsr     -462(a6)                ; _LVODisownBlitter

        move.l  4.w,a6
        move.l  _gfxbase,a1
        jsr     -414(a6)                ; close graphics.library

        jsr     -138(a6)                ; _LVOPermit

        moveq   #0,d0
        rts
        
;--------------------------------------------------------------------
; Hex to Ascii conversion routine.
; IN: D0.l = Number, A3 = Pointer to string, A4 = Pointer to _values.
;--------------------------------------------------------------------

converter
        move.l  d0,d6   ; store number.
        moveq   #28,d7  ; bits to be shifted.
do_conv
        lsr.l   d7,d0   ; d0.b is now MSB
        and.w   #$000F,d0
        move.b  (A4,d0.w),(a3)+ ; Copy value to string.

        move.l  d6,d0
        subq.w   #4,d7
        cmp.w     #-4,d7
        bne     do_conv 

        rts

;-------------------------
; AGA chipset tester.
; Setpatch MUST be loaded!
;-------------------------

AGA_Check
        lea     gfx_lib,a1
        moveq   #0,d0
        move.l  4.w,a6
        jsr     -552(a6)

        btst    #2,$EC(A0)
        bne.s   is_aa
        moveq   #0,d7
        bra.s   not_aga
is_aa   move.l  #'AGA.',d7      

not_aga move.l  a0,a1
        jsr     -414(a6)
        rts

;--------------------------------------
; Store VBR value.
; Processor MUST be in Supervisor mode.
;--------------------------------------

GetVBR  movec   VBR,D0
        lea     _vectorbase,a0
        move.l  d0,(a0)
        RTE

;-------------------
; dos.library stuff.
;-------------------

OpenDOS:
        lea      dos_name,a1              ; dos.library
        moveq    #0,d0                    ; any version

	move.l	a6,-(sp)
	move.l	4.w,a6
	jsr	-552(a6) 		; _LVOOpenLibrary
	move.l	(sp)+,a6

	move.l   d0,_dosbase		; store Dos.library pointer
        beq      ERROR                    

	move.l	a6,-(sp)
	move.l	_dosbase,a6
	jsr	-60(a6) 		; _LVOOutput
	move.l	(sp)+,a6

	move.l   d0,_stdout             ; store descriptor.
        beq      CloseDOS                

        rts                               

CloseDOS:
        move.l   _dosbase,a1             
	move.l	a6,-(sp)
	move.l	4.w,a6
	jsr	-414(a6) 		; _LVOCloseLibrary
	move.l	(sp)+,a6
        rts                                

ERROR:  moveq	#0,d0        		; exit to shell in case of error.
        rts

;-------------
; Write text. 
;-------------

Writer	move.l	a6,-(sp)
	move.l	_dosbase,a6
	jsr	-48(a6) 		; _LVOWrite
	move.l	(sp)+,a6
	rts

;------------------------------------------------------------------------
; Text and misc data for startup/restore routines.
;------------------------------------------------------------------------


	section	stup_data,data
	

_status 	dc.w    0

_values 	dc.b    '0123456789ABCDEF'

_chipmem        dc.l    0
_fastmem        dc.l    0

_stdout		dc.l	0
_gfxbase        dc.l    0
_dosbase	dc.l	0
_oldcopper      dc.l    0
_oldview        dc.l    0
_vectorbase     dc.l    0
_intenar        dc.w    0
_intreqr        dc.w    0
_dmaconr        dc.w    0
_adkconr        dc.w    0
_int3save       dc.l    0

dos_name        dc.b    "dos.library",0
gfx_lib 	dc.b    "graphics.library",0,0

_header dc.b 10,' Hardware Configuration Test 1.10  1996-97 Flynn/Energy '
        dc.b 10,' -------------------------------------------------------',10
        dc.b 10,' 680'
_cpu    dc.b 'x0 processor found...........[68020+ needed]'

_header_long EQU *-_header

_aga    dc.b 10,' AGA chipset found..................[AGA needed]'
               
_aga_long EQU *-_aga

_not_aga dc.b 10,' AGA chipset not found..............[AGA needed]'

_not_aga_long EQU *-_not_aga

_pal    dc.b  10,' PAL display........................[PAL needed]'

_pal_long       equ     *-_pal

_ntsc   dc.b  10,' System is not in PAL mode..........[PAL needed]'

_ntsc_long      EQU     *-_ntsc

_chip   dc.b  10,10,' Chip Memory: $'

_cmem   dc.b  '00000000 bytes available.'

        dc.b  10,' Fast Memory: $'

_fmem   dc.b  '00000000 bytes available.'

_chip_long      equ     *-_chip

_abort1 dc.b  10,10,' Hardware test failed. Program aborted...',10,10

_abort1_long   EQU *-_abort1

_abort2 dc.b  10,10,' Sorry, this demo requires at least 2Mb of FAST Memory.'
        dc.b  10,10

_abort2_long   EQU *-_abort2
        
_passd dc.b 10,10,' Sorry for the crap code, made in a real hurry...',10,10

_passd_long EQU *-_passd


;----------------------------------------------------------------------------
; Real code starts here if everything went ok.
;----------------------------------------------------------------------------


	section	democode,code
	
                
_maincode       
